var gExpandedCols = {
  init: function() {
    window.removeEventListener("load", gExpandedCols.init, false);

    ftvItem.prototype.getText = function gt(aColName) {
      // nsIMsgFolder uses -1 as a magic number to mean "I don't know". In those
      // cases we shouldn't display it to the user.
      function fixNum(aNumber) {
        return aNumber <= 0 ? "" : aNumber;
      }

      switch (aColName) {
        case "folderNameCol":
          // Note: Although this looks like ftvItem.text(), it isn't quite
          // the same, as we are adjusting when we show the unread count.
          let text;
          if (this.useServerNameOnly)
            text = this._folder.server.prettyName;
          else {
            text = this._folder.abbreviatedName;
            if (this.addServerName)
              text += " - " + this._folder.server.prettyName;
          }

          // If the unread column is shown, we don't need to add the count
          if (!document.getElementById("folderUnreadCol").hidden)
            return text;

          // Yeah, we hard-code this, but so did the old code...
          let unread = this._folder.getNumUnread(false);
          if (unread > 0)
            text += " (" + unread + ")";
          return text;

        case "folderUnreadCol":
          return fixNum(this._folder.getNumUnread(false));
        case "folderTotalCol":
          return fixNum(this._folder.getTotalMessages(false));
        case "folderSizeCol":
          var size;
          try {
            size = this._folder.sizeOnDisk;
          } catch(ex) {
            return "???";
          }
          if (size == 0)
            return "";
          size = Math.round(size / 1024);
          let units = "KB";
          if (size > 999) {
            size = Math.round(size / 1024);
            units = "MB";
          }
          return String(size) + units;
      }
    };

    // Now fix the folder-tree to actually ask for this text...
    gFolderTreeView.getCellText = function gct(aRow, aCol) {
      return gFolderTreeView._rowMap[aRow].getText(aCol.id);
    };

    // Only show attributes on the first col
    gFolderTreeView.storedEfcGetCellProperties = gFolderTreeView.getCellProperties;
    gFolderTreeView.getCellProperties = function gcp(aRow, aCol, aProps) {
      if (aCol.id != "folderUnreadCol" &&
          aCol.id != "folderTotalCol" &&
          aCol.id != "folderSizeCol")
        return gFolderTreeView.storedEfcGetCellProperties(aRow, aCol, aProps);

      return "";
    };

    gFolderTreeView._treeElement.setAttribute("hidecolumnpicker", "false");
    document.getElementById("folderNameCol").setAttribute("hideheader", "false");
  }
};

window.addEventListener("load", gExpandedCols.init, false);